﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

public partial class _Default : System.Web.UI.Page
{
    #region events
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            InitializeModuleCarto();
            AddRaster();
        }

    }
    /// <summary>
    /// To get a postback after a pan or zoom to see the behaviour of the markers
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btReload_Click(object sender, EventArgs e)
    {

    }
    #endregion



    /// <summary>
    /// Initialize the map, with appearence and background layer
    /// </summary>
    #region Module Carto Initialisation

    private void InitializeModuleCarto()
    {
        InitializeInchedPerUnit();
        InitializeMapAppearance();
        InitializeBackgroundLayer();

        Map1.MapUnit = GeographyUnit.Meter;
    }

    #region Init Current Scale
    public const int DotsPerInch = 96;
    public Dictionary<string, double> inchesPerUnits;

    public void InitializeInchedPerUnit()
    {
        inchesPerUnits = new Dictionary<string, double>();
        inchesPerUnits.Add("DecimalDegree", 4374754);
        inchesPerUnits.Add("Feet", 12.0);
        inchesPerUnits.Add("Meter", 39.3701);
    }
    #endregion

    private void InitializeMapAppearance()
    {
        Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
        Map1.MapTools.OverlaySwitcher.Enabled = false;
        Map1.MapTools.MouseCoordinate.Enabled = true;
        Map1.MapTools.PanZoomBar.Enabled = true;
        Map1.MapTools.ScaleLine.Enabled = true;
        Map1.MapTools.Logo.Enabled = true;
        Map1.EditOverlay.EditSettings.IsDraggable = true;
        Map1.EditOverlay.EditSettings.IsReshapable = true;
        Map1.EditOverlay.EditSettings.IsResizable = false;
        Map1.EditOverlay.EditSettings.IsRotatable = false;

        Map1.EditOverlay.Style.FillColor = GeoColor.FromArgb(77, 255, 255, 0);
        Map1.EditOverlay.Style.OutlineColor = GeoColor.FromArgb(77, 255, 255, 0);
        Map1.EditOverlay.Style.OutlineWidth = 3;


    }

    private void InitializeBackgroundLayer()
    {

        GoogleOverlay gOverlay = new GoogleOverlay();
        gOverlay.Name = "Google Overlay";
        gOverlay.GoogleMapType = GoogleMapType.Hybrid;

        gOverlay.JavaScriptLibraryUri = new Uri("http://maps.google.com/maps?file=api&amp;v=2&amp;client=gme-geosys&amp;sensor=false");
        gOverlay.IsBaseOverlay = true;
        Map1.CustomOverlays.Add(gOverlay);

    }



    #endregion

    #region Raster


    private void AddRaster()
    {
        LayerOverlay LoProduct = new LayerOverlay("TestRasterOverlay");

        LoProduct.Name = "TestRaster";
        LoProduct.IsBaseOverlay = false;
        LoProduct.TileType = TileType.SingleTile;
        LoProduct.IsVisibleInOverlaySwitcher = true;
        LoProduct.IsVisible = true;

        GdiPlusRasterLayer layerImage = new GdiPlusRasterLayer(Server.MapPath("~/Images/testRaster2.png"));
        LoProduct.Layers.Add(layerImage);

        Map1.CustomOverlays.Add(LoProduct);
        layerImage.Open();
        Map1.CurrentExtent = layerImage.GetBoundingBox();
        layerImage.Close();
    }


    #endregion


}
